/* PixbufButton.c generated by valac 0.25.1, the Vala compiler
 * generated from PixbufButton.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_PIXBUF_BUTTON (pixbuf_button_get_type ())
#define PIXBUF_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXBUF_BUTTON, PixbufButton))
#define PIXBUF_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXBUF_BUTTON, PixbufButtonClass))
#define IS_PIXBUF_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXBUF_BUTTON))
#define IS_PIXBUF_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXBUF_BUTTON))
#define PIXBUF_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXBUF_BUTTON, PixbufButtonClass))

typedef struct _PixbufButton PixbufButton;
typedef struct _PixbufButtonClass PixbufButtonClass;
typedef struct _PixbufButtonPrivate PixbufButtonPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PixbufButton {
	GtkButton parent_instance;
	PixbufButtonPrivate * priv;
};

struct _PixbufButtonClass {
	GtkButtonClass parent_class;
};

struct _PixbufButtonPrivate {
	GdkPixbuf* bg;
	GtkMenu* menu;
	gchar* menu_string;
};


static gpointer pixbuf_button_parent_class = NULL;

GType pixbuf_button_get_type (void) G_GNUC_CONST;
#define PIXBUF_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PIXBUF_BUTTON, PixbufButtonPrivate))
enum  {
	PIXBUF_BUTTON_DUMMY_PROPERTY
};
PixbufButton* pixbuf_button_new (gboolean show_menu, const gchar* menu_string);
PixbufButton* pixbuf_button_construct (GType object_type, gboolean show_menu, const gchar* menu_string);
static gboolean pixbuf_button_button_release_cb (PixbufButton* self, GdkEventButton* evt);
static gboolean _pixbuf_button_button_release_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void pixbuf_button_source_link_item_activate_cb (PixbufButton* self);
static void _pixbuf_button_source_link_item_activate_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static gboolean pixbuf_button_real_draw (GtkWidget* base, cairo_t* c);
void pixbuf_button_set_bg (PixbufButton* self, GdkPixbuf* bg);
static GObject * pixbuf_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void pixbuf_button_finalize (GObject* obj);


static gboolean _pixbuf_button_button_release_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = pixbuf_button_button_release_cb ((PixbufButton*) self, event);
	return result;
}


PixbufButton* pixbuf_button_construct (GType object_type, gboolean show_menu, const gchar* menu_string) {
	PixbufButton * self = NULL;
	gboolean _tmp0_ = FALSE;
	self = (PixbufButton*) g_object_new (object_type, NULL);
	_tmp0_ = show_menu;
	if (_tmp0_) {
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), "button-press-event", (GCallback) _pixbuf_button_button_release_cb_gtk_widget_button_press_event, self, 0);
		_tmp1_ = menu_string;
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (self->priv->menu_string);
		self->priv->menu_string = _tmp2_;
	}
	return self;
}


PixbufButton* pixbuf_button_new (gboolean show_menu, const gchar* menu_string) {
	return pixbuf_button_construct (TYPE_PIXBUF_BUTTON, show_menu, menu_string);
}


static void _pixbuf_button_source_link_item_activate_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	pixbuf_button_source_link_item_activate_cb ((PixbufButton*) self);
}


static gboolean pixbuf_button_button_release_cb (PixbufButton* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_val_if_fail (IS_PIXBUF_BUTTON (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp0_ = evt;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ == ((guint) GDK_BUTTON_SECONDARY)) {
		GtkMenu* _tmp2_ = NULL;
		GtkMenuItem* source_link_item = NULL;
		const gchar* _tmp3_ = NULL;
		GtkMenuItem* _tmp4_ = NULL;
		GtkMenuItem* _tmp5_ = NULL;
		GtkMenu* _tmp6_ = NULL;
		GtkMenuItem* _tmp7_ = NULL;
		GtkMenu* _tmp8_ = NULL;
		GtkMenu* _tmp9_ = NULL;
		GdkEventButton* _tmp10_ = NULL;
		guint _tmp11_ = 0U;
		GdkEventButton* _tmp12_ = NULL;
		guint32 _tmp13_ = 0U;
		_tmp2_ = (GtkMenu*) gtk_menu_new ();
		g_object_ref_sink (_tmp2_);
		_g_object_unref0 (self->priv->menu);
		self->priv->menu = _tmp2_;
		_tmp3_ = _ ("Copy link");
		_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp3_);
		g_object_ref_sink (_tmp4_);
		source_link_item = _tmp4_;
		_tmp5_ = source_link_item;
		g_signal_connect_object (_tmp5_, "activate", (GCallback) _pixbuf_button_source_link_item_activate_cb_gtk_menu_item_activate, self, 0);
		_tmp6_ = self->priv->menu;
		_tmp7_ = source_link_item;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_CONTAINER, GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_WIDGET, GtkWidget));
		_tmp8_ = self->priv->menu;
		gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GTK_TYPE_WIDGET, GtkWidget));
		_tmp9_ = self->priv->menu;
		_tmp10_ = evt;
		_tmp11_ = _tmp10_->button;
		_tmp12_ = evt;
		_tmp13_ = _tmp12_->time;
		gtk_menu_popup (_tmp9_, NULL, NULL, NULL, NULL, _tmp11_, _tmp13_);
		result = TRUE;
		_g_object_unref0 (source_link_item);
		return result;
	}
	result = FALSE;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void pixbuf_button_source_link_item_activate_cb (PixbufButton* self) {
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_ = NULL;
	GtkClipboard* _tmp1_ = NULL;
	GtkClipboard* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (IS_PIXBUF_BUTTON (self));
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	clipboard = _tmp2_;
	_tmp3_ = self->priv->menu_string;
	gtk_clipboard_set_text (clipboard, _tmp3_, -1);
	_g_object_unref0 (clipboard);
}


static gboolean pixbuf_button_real_draw (GtkWidget* base, cairo_t* c) {
	PixbufButton * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_ = NULL;
	cairo_t* _tmp6_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PIXBUF_BUTTON, PixbufButton);
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = self->priv->bg;
	if (_tmp0_ != NULL) {
		GtkStyleContext* context = NULL;
		GtkStyleContext* _tmp1_ = NULL;
		GtkStyleContext* _tmp2_ = NULL;
		GtkStyleContext* _tmp3_ = NULL;
		cairo_t* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
		_tmp2_ = _g_object_ref0 (_tmp1_);
		context = _tmp2_;
		_tmp3_ = context;
		_tmp4_ = c;
		_tmp5_ = self->priv->bg;
		gtk_render_icon (_tmp3_, _tmp4_, _tmp5_, (gdouble) 0, (gdouble) 0);
		_g_object_unref0 (context);
	}
	_tmp6_ = c;
	GTK_WIDGET_CLASS (pixbuf_button_parent_class)->draw (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BUTTON, GtkButton), GTK_TYPE_WIDGET, GtkWidget), _tmp6_);
	result = FALSE;
	return result;
}


void pixbuf_button_set_bg (PixbufButton* self, GdkPixbuf* bg) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	GdkPixbuf* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	g_return_if_fail (IS_PIXBUF_BUTTON (self));
	g_return_if_fail (GDK_IS_PIXBUF (bg));
	_tmp0_ = bg;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->bg);
	self->priv->bg = _tmp1_;
	_tmp2_ = bg;
	_tmp3_ = gdk_pixbuf_get_width (_tmp2_);
	_tmp4_ = bg;
	_tmp5_ = gdk_pixbuf_get_height (_tmp4_);
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), _tmp3_, _tmp5_);
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
}


static GObject * pixbuf_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PixbufButton * self;
	GtkStyleContext* _tmp0_ = NULL;
	parent_class = G_OBJECT_CLASS (pixbuf_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PIXBUF_BUTTON, PixbufButton);
	gtk_container_set_border_width (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_CONTAINER, GtkContainer), (guint) 0);
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
	gtk_style_context_add_class (_tmp0_, "pixbuf-button");
	return obj;
}


static void pixbuf_button_class_init (PixbufButtonClass * klass) {
	pixbuf_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PixbufButtonPrivate));
	((GtkWidgetClass *) klass)->draw = pixbuf_button_real_draw;
	G_OBJECT_CLASS (klass)->constructor = pixbuf_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = pixbuf_button_finalize;
}


static void pixbuf_button_instance_init (PixbufButton * self) {
	self->priv = PIXBUF_BUTTON_GET_PRIVATE (self);
}


static void pixbuf_button_finalize (GObject* obj) {
	PixbufButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PIXBUF_BUTTON, PixbufButton);
	_g_object_unref0 (self->priv->bg);
	_g_object_unref0 (self->priv->menu);
	_g_free0 (self->priv->menu_string);
	G_OBJECT_CLASS (pixbuf_button_parent_class)->finalize (obj);
}


/**
 * A button with the given pixbuf as background.
 */
GType pixbuf_button_get_type (void) {
	static volatile gsize pixbuf_button_type_id__volatile = 0;
	if (g_once_init_enter (&pixbuf_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PixbufButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pixbuf_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PixbufButton), 0, (GInstanceInitFunc) pixbuf_button_instance_init, NULL };
		GType pixbuf_button_type_id;
		pixbuf_button_type_id = g_type_register_static (GTK_TYPE_BUTTON, "PixbufButton", &g_define_type_info, 0);
		g_once_init_leave (&pixbuf_button_type_id__volatile, pixbuf_button_type_id);
	}
	return pixbuf_button_type_id__volatile;
}



