/* TweetListBox.c generated by valac 0.25.1, the Vala compiler
 * generated from TweetListBox.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_TWEET_LIST_BOX (tweet_list_box_get_type ())
#define TWEET_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWEET_LIST_BOX, TweetListBox))
#define TWEET_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWEET_LIST_BOX, TweetListBoxClass))
#define IS_TWEET_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWEET_LIST_BOX))
#define IS_TWEET_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWEET_LIST_BOX))
#define TWEET_LIST_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWEET_LIST_BOX, TweetListBoxClass))

typedef struct _TweetListBox TweetListBox;
typedef struct _TweetListBoxClass TweetListBoxClass;
typedef struct _TweetListBoxPrivate TweetListBoxPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TweetListBox {
	GtkListBox parent_instance;
	TweetListBoxPrivate * priv;
};

struct _TweetListBoxClass {
	GtkListBoxClass parent_class;
};

struct _TweetListBoxPrivate {
	GtkStack* placeholder;
	GtkLabel* no_entries_label;
};


static gpointer tweet_list_box_parent_class = NULL;

GType tweet_list_box_get_type (void) G_GNUC_CONST;
#define TWEET_LIST_BOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TWEET_LIST_BOX, TweetListBoxPrivate))
enum  {
	TWEET_LIST_BOX_DUMMY_PROPERTY
};
TweetListBox* tweet_list_box_new (gboolean show_placeholder);
TweetListBox* tweet_list_box_construct (GType object_type, gboolean show_placeholder);
static void tweet_list_box_add_placeholder (TweetListBox* self);
void tweet_list_box_set_empty (TweetListBox* self);
void tweet_list_box_set_unempty (TweetListBox* self);
GtkStack* tweet_list_box_get_placeholder (TweetListBox* self);
void tweet_list_box_remove_all (TweetListBox* self);
static void __lambda75_ (TweetListBox* self, GtkWidget* w);
static void ___lambda75__gtk_callback (GtkWidget* widget, gpointer self);
void tweet_list_box_set_placeholder_text (TweetListBox* self, const gchar* text);
void tweet_list_box_reset_placeholder_text (TweetListBox* self);
static GObject * tweet_list_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tweet_list_box_finalize (GObject* obj);


TweetListBox* tweet_list_box_construct (GType object_type, gboolean show_placeholder) {
	TweetListBox * self = NULL;
	gboolean _tmp0_ = FALSE;
	GtkStyleContext* _tmp1_ = NULL;
	self = (TweetListBox*) g_object_new (object_type, NULL);
	_tmp0_ = show_placeholder;
	if (_tmp0_) {
		tweet_list_box_add_placeholder (self);
	}
	_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
	gtk_style_context_add_class (_tmp1_, "stream");
	gtk_list_box_set_selection_mode (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LIST_BOX, GtkListBox), GTK_SELECTION_NONE);
	return self;
}


TweetListBox* tweet_list_box_new (gboolean show_placeholder) {
	return tweet_list_box_construct (TYPE_TWEET_LIST_BOX, show_placeholder);
}


static void tweet_list_box_add_placeholder (TweetListBox* self) {
	GtkStack* _tmp0_ = NULL;
	GtkStack* _tmp1_ = NULL;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp2_ = NULL;
	GtkStack* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GtkLabel* _tmp5_ = NULL;
	GtkLabel* _tmp6_ = NULL;
	GtkStyleContext* _tmp7_ = NULL;
	GtkLabel* _tmp8_ = NULL;
	GtkStack* _tmp9_ = NULL;
	GtkLabel* _tmp10_ = NULL;
	GtkStack* _tmp11_ = NULL;
	GtkStack* _tmp12_ = NULL;
	GtkStack* _tmp13_ = NULL;
	GtkStack* _tmp14_ = NULL;
	GtkStack* _tmp15_ = NULL;
	g_return_if_fail (IS_TWEET_LIST_BOX (self));
	_tmp0_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->placeholder);
	self->priv->placeholder = _tmp0_;
	_tmp1_ = self->priv->placeholder;
	gtk_stack_set_transition_type (_tmp1_, GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN);
	_tmp2_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp2_);
	spinner = _tmp2_;
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (spinner, GTK_TYPE_WIDGET, GtkWidget), 60, 60);
	gtk_spinner_start (spinner);
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (spinner, GTK_TYPE_WIDGET, GtkWidget));
	_tmp3_ = self->priv->placeholder;
	gtk_stack_add_named (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (spinner, GTK_TYPE_WIDGET, GtkWidget), "spinner");
	_tmp4_ = _ ("No entries found");
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->no_entries_label);
	self->priv->no_entries_label = _tmp5_;
	_tmp6_ = self->priv->no_entries_label;
	_tmp7_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_WIDGET, GtkWidget));
	gtk_style_context_add_class (_tmp7_, "dim-label");
	_tmp8_ = self->priv->no_entries_label;
	g_object_set (_tmp8_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	_tmp9_ = self->priv->placeholder;
	_tmp10_ = self->priv->no_entries_label;
	gtk_stack_add_named (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GTK_TYPE_WIDGET, GtkWidget), "no-entries");
	_tmp11_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp11_, "spinner");
	_tmp12_ = self->priv->placeholder;
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GTK_TYPE_WIDGET, GtkWidget));
	_tmp13_ = self->priv->placeholder;
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GTK_TYPE_WIDGET, GtkWidget), GTK_ALIGN_CENTER);
	_tmp14_ = self->priv->placeholder;
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GTK_TYPE_WIDGET, GtkWidget), GTK_ALIGN_CENTER);
	_tmp15_ = self->priv->placeholder;
	gtk_list_box_set_placeholder (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LIST_BOX, GtkListBox), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GTK_TYPE_WIDGET, GtkWidget));
	_g_object_unref0 (spinner);
}


void tweet_list_box_set_empty (TweetListBox* self) {
	GtkStack* _tmp0_ = NULL;
	g_return_if_fail (IS_TWEET_LIST_BOX (self));
	_tmp0_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp0_, "no-entries");
}


void tweet_list_box_set_unempty (TweetListBox* self) {
	GtkStack* _tmp0_ = NULL;
	g_return_if_fail (IS_TWEET_LIST_BOX (self));
	_tmp0_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp0_, "spinner");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GtkStack* tweet_list_box_get_placeholder (TweetListBox* self) {
	GtkStack* result = NULL;
	GtkStack* _tmp0_ = NULL;
	GtkStack* _tmp1_ = NULL;
	g_return_val_if_fail (IS_TWEET_LIST_BOX (self), NULL);
	_tmp0_ = self->priv->placeholder;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static void __lambda75_ (TweetListBox* self, GtkWidget* w) {
	GtkWidget* _tmp0_ = NULL;
	g_return_if_fail (GTK_IS_WIDGET (w));
	_tmp0_ = w;
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_CONTAINER, GtkContainer), _tmp0_);
}


static void ___lambda75__gtk_callback (GtkWidget* widget, gpointer self) {
	__lambda75_ ((TweetListBox*) self, widget);
}


void tweet_list_box_remove_all (TweetListBox* self) {
	g_return_if_fail (IS_TWEET_LIST_BOX (self));
	gtk_container_foreach (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_CONTAINER, GtkContainer), ___lambda75__gtk_callback, self);
}


void tweet_list_box_set_placeholder_text (TweetListBox* self, const gchar* text) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (IS_TWEET_LIST_BOX (self));
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->no_entries_label;
	_tmp1_ = text;
	gtk_label_set_label (_tmp0_, _tmp1_);
}


void tweet_list_box_reset_placeholder_text (TweetListBox* self) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (IS_TWEET_LIST_BOX (self));
	_tmp0_ = self->priv->no_entries_label;
	_tmp1_ = _ ("No entries found");
	gtk_label_set_label (_tmp0_, _tmp1_);
}


static GObject * tweet_list_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TweetListBox * self;
	parent_class = G_OBJECT_CLASS (tweet_list_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEET_LIST_BOX, TweetListBox);
	tweet_list_box_add_placeholder (self);
	return obj;
}


static void tweet_list_box_class_init (TweetListBoxClass * klass) {
	tweet_list_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TweetListBoxPrivate));
	G_OBJECT_CLASS (klass)->constructor = tweet_list_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = tweet_list_box_finalize;
}


static void tweet_list_box_instance_init (TweetListBox * self) {
	self->priv = TWEET_LIST_BOX_GET_PRIVATE (self);
	self->priv->placeholder = NULL;
}


static void tweet_list_box_finalize (GObject* obj) {
	TweetListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEET_LIST_BOX, TweetListBox);
	_g_object_unref0 (self->priv->placeholder);
	_g_object_unref0 (self->priv->no_entries_label);
	G_OBJECT_CLASS (tweet_list_box_parent_class)->finalize (obj);
}


GType tweet_list_box_get_type (void) {
	static volatile gsize tweet_list_box_type_id__volatile = 0;
	if (g_once_init_enter (&tweet_list_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TweetListBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tweet_list_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TweetListBox), 0, (GInstanceInitFunc) tweet_list_box_instance_init, NULL };
		GType tweet_list_box_type_id;
		tweet_list_box_type_id = g_type_register_static (GTK_TYPE_LIST_BOX, "TweetListBox", &g_define_type_info, 0);
		g_once_init_leave (&tweet_list_box_type_id__volatile, tweet_list_box_type_id);
	}
	return tweet_list_box_type_id__volatile;
}



