/* ImageDialog.c generated by valac 0.25.1, the Vala compiler
 * generated from ImageDialog.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define TYPE_IMAGE_DIALOG (image_dialog_get_type ())
#define IMAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_DIALOG, ImageDialog))
#define IMAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_DIALOG, ImageDialogClass))
#define IS_IMAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_DIALOG))
#define IS_IMAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_DIALOG))
#define IMAGE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_DIALOG, ImageDialogClass))

typedef struct _ImageDialog ImageDialog;
typedef struct _ImageDialogClass ImageDialogClass;
typedef struct _ImageDialogPrivate ImageDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ImageDialog {
	GtkWindow parent_instance;
	ImageDialogPrivate * priv;
};

struct _ImageDialogClass {
	GtkWindowClass parent_class;
};

struct _ImageDialogPrivate {
	GtkScrolledWindow* scroller;
	GtkImage* image;
	GtkMenu* image_context_menu;
	GtkWindow* parent;
	gchar* path;
	gdouble dnd_x;
	gdouble dnd_y;
};


static gpointer image_dialog_parent_class = NULL;

GType image_dialog_get_type (void) G_GNUC_CONST;
#define IMAGE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMAGE_DIALOG, ImageDialogPrivate))
enum  {
	IMAGE_DIALOG_DUMMY_PROPERTY
};
ImageDialog* image_dialog_new (GtkWindow* parent, const gchar* path);
ImageDialog* image_dialog_construct (GType object_type, GtkWindow* parent, const gchar* path);
static gboolean image_dialog_event_box_motion_notify_cb (ImageDialog* self, GdkEventMotion* evt);
static gboolean _image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean image_dialog_event_box_button_press_cb (ImageDialog* self, GdkEventButton* evt);
static gboolean _image_dialog_event_box_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void image_dialog_save_item_activated_cb (ImageDialog* self);
gchar* utils_get_file_name (const gchar* path);
static void _image_dialog_save_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static gboolean image_dialog_button_press_event_cb (ImageDialog* self, GdkEventButton* evt);
static gboolean _image_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean image_dialog_key_press_event_cb (ImageDialog* self);
static gboolean _image_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static void image_dialog_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


ImageDialog* image_dialog_construct (GType object_type, GtkWindow* parent, const gchar* path) {
	ImageDialog * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GtkWindow* _tmp2_ = NULL;
	GtkWindow* _tmp3_ = NULL;
	GdkPixbuf* pixbuf = NULL;
	gint img_width = 0;
	GdkPixbuf* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gint img_height = 0;
	GdkPixbuf* _tmp24_ = NULL;
	gint _tmp25_ = 0;
	gint win_width = 0;
	gint win_height = 0;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gboolean _tmp34_ = FALSE;
	gint _tmp35_ = 0;
	gboolean _tmp42_ = FALSE;
	gint _tmp43_ = 0;
	GtkScrolledWindow* _tmp50_ = NULL;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	GtkWindow* _tmp53_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (GTK_IS_WINDOW (parent), NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = (ImageDialog*) g_object_new (object_type, NULL);
	_tmp0_ = path;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp1_;
	_tmp2_ = parent;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->parent);
	self->priv->parent = _tmp3_;
	pixbuf = NULL;
	{
		GdkPixbuf* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		GdkPixbuf* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_ = NULL;
		_tmp5_ = path;
		_tmp6_ = gdk_pixbuf_new_from_file (_tmp5_, &_inner_error_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch104_g_error;
		}
		_tmp7_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp7_;
		_g_object_unref0 (_tmp4_);
	}
	goto __finally104;
	__catch104_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_critical ("ImageDialog.vala:43: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally104:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pixbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		const gchar* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		_tmp10_ = path;
		_tmp11_ = g_str_has_suffix (_tmp10_, "gif");
		if (_tmp11_) {
			GdkPixbufAnimation* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			GdkPixbufAnimation* _tmp14_ = NULL;
			GtkImage* _tmp15_ = NULL;
			_tmp13_ = path;
			_tmp14_ = gdk_pixbuf_animation_new_from_file (_tmp13_, &_inner_error_);
			_tmp12_ = _tmp14_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch105_g_error;
			}
			_tmp15_ = self->priv->image;
			g_object_set (_tmp15_, "pixbuf-animation", _tmp12_, NULL);
			_g_object_unref0 (_tmp12_);
		} else {
			GdkPixbuf* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			GdkPixbuf* _tmp18_ = NULL;
			GtkImage* _tmp19_ = NULL;
			_tmp17_ = path;
			_tmp18_ = gdk_pixbuf_new_from_file (_tmp17_, &_inner_error_);
			_tmp16_ = _tmp18_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch105_g_error;
			}
			_tmp19_ = self->priv->image;
			g_object_set (_tmp19_, "pixbuf", _tmp16_, NULL);
			_g_object_unref0 (_tmp16_);
		}
	}
	goto __finally105;
	__catch105_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_critical ("ImageDialog.vala:51: %s", _tmp21_);
		_g_error_free0 (e);
	}
	__finally105:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pixbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp22_ = pixbuf;
	_tmp23_ = gdk_pixbuf_get_width (_tmp22_);
	img_width = _tmp23_;
	_tmp24_ = pixbuf;
	_tmp25_ = gdk_pixbuf_get_height (_tmp24_);
	img_height = _tmp25_;
	win_width = 800;
	win_height = 600;
	_tmp26_ = img_width;
	_tmp27_ = gdk_screen_width ();
	if (((gdouble) _tmp26_) <= (_tmp27_ * 0.7)) {
		gint _tmp28_ = 0;
		GtkScrolledWindow* _tmp29_ = NULL;
		_tmp28_ = img_width;
		win_width = _tmp28_;
		_tmp29_ = self->priv->scroller;
		g_object_set (_tmp29_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	}
	_tmp30_ = img_height;
	_tmp31_ = gdk_screen_height ();
	if (((gdouble) _tmp30_) <= (_tmp31_ * 0.7)) {
		gint _tmp32_ = 0;
		GtkScrolledWindow* _tmp33_ = NULL;
		_tmp32_ = img_height;
		win_height = _tmp32_;
		_tmp33_ = self->priv->scroller;
		g_object_set (_tmp33_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
	}
	_tmp35_ = win_width;
	if (_tmp35_ < 800) {
		gint _tmp36_ = 0;
		_tmp36_ = win_height;
		_tmp34_ = _tmp36_ == 600;
	} else {
		_tmp34_ = FALSE;
	}
	if (_tmp34_) {
		gint add_width = 0;
		GtkScrolledWindow* _tmp37_ = NULL;
		GtkWidget* _tmp38_ = NULL;
		gint _tmp39_ = 0;
		gint _tmp40_ = 0;
		gint _tmp41_ = 0;
		_tmp37_ = self->priv->scroller;
		_tmp38_ = gtk_scrolled_window_get_vscrollbar (_tmp37_);
		gtk_widget_get_preferred_width (_tmp38_, NULL, &_tmp39_);
		add_width = _tmp39_;
		_tmp40_ = win_width;
		_tmp41_ = add_width;
		win_width = _tmp40_ + _tmp41_;
	}
	_tmp43_ = win_width;
	if (_tmp43_ == 800) {
		gint _tmp44_ = 0;
		_tmp44_ = win_height;
		_tmp42_ = _tmp44_ < 600;
	} else {
		_tmp42_ = FALSE;
	}
	if (_tmp42_) {
		gint add_height = 0;
		GtkScrolledWindow* _tmp45_ = NULL;
		GtkWidget* _tmp46_ = NULL;
		gint _tmp47_ = 0;
		gint _tmp48_ = 0;
		gint _tmp49_ = 0;
		_tmp45_ = self->priv->scroller;
		_tmp46_ = gtk_scrolled_window_get_hscrollbar (_tmp45_);
		gtk_widget_get_preferred_width (_tmp46_, NULL, &_tmp47_);
		add_height = _tmp47_;
		_tmp48_ = win_height;
		_tmp49_ = add_height;
		win_height = _tmp48_ + _tmp49_;
	}
	_tmp50_ = self->priv->scroller;
	_tmp51_ = win_width;
	_tmp52_ = win_height;
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, GTK_TYPE_WIDGET, GtkWidget), _tmp51_, _tmp52_);
	gtk_window_set_modal (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), TRUE);
	_tmp53_ = parent;
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), _tmp53_);
	_g_object_unref0 (pixbuf);
	return self;
}


ImageDialog* image_dialog_new (GtkWindow* parent, const gchar* path) {
	return image_dialog_construct (TYPE_IMAGE_DIALOG, parent, path);
}


static gboolean image_dialog_event_box_motion_notify_cb (ImageDialog* self, GdkEventMotion* evt) {
	gboolean result = FALSE;
	GdkEventMotion* _tmp0_ = NULL;
	GdkModifierType _tmp1_ = 0;
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp0_ = evt;
	_tmp1_ = _tmp0_->state;
	if ((_tmp1_ & GDK_MODIFIER_MASK) >= GDK_BUTTON2_MASK) {
		gdouble diff_x = 0.0;
		gdouble _tmp2_ = 0.0;
		GdkEventMotion* _tmp3_ = NULL;
		gdouble _tmp4_ = 0.0;
		gdouble diff_y = 0.0;
		gdouble _tmp5_ = 0.0;
		GdkEventMotion* _tmp6_ = NULL;
		gdouble _tmp7_ = 0.0;
		GtkScrolledWindow* _tmp8_ = NULL;
		GtkAdjustment* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		GtkScrolledWindow* _tmp11_ = NULL;
		GtkAdjustment* _tmp12_ = NULL;
		GtkAdjustment* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		GtkScrolledWindow* _tmp17_ = NULL;
		GtkAdjustment* _tmp18_ = NULL;
		GtkAdjustment* _tmp19_ = NULL;
		GtkScrolledWindow* _tmp20_ = NULL;
		GtkAdjustment* _tmp21_ = NULL;
		GtkAdjustment* _tmp22_ = NULL;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_ = 0.0;
		_tmp2_ = self->priv->dnd_x;
		_tmp3_ = evt;
		_tmp4_ = _tmp3_->x;
		diff_x = _tmp2_ - _tmp4_;
		_tmp5_ = self->priv->dnd_y;
		_tmp6_ = evt;
		_tmp7_ = _tmp6_->y;
		diff_y = _tmp5_ - _tmp7_;
		_tmp8_ = self->priv->scroller;
		_tmp9_ = gtk_scrolled_window_get_vadjustment (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = self->priv->scroller;
		_tmp12_ = gtk_scrolled_window_get_vadjustment (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = gtk_adjustment_get_value (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = diff_y;
		gtk_adjustment_set_value (_tmp13_, _tmp15_ + _tmp16_);
		_tmp17_ = self->priv->scroller;
		_tmp18_ = gtk_scrolled_window_get_hadjustment (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = self->priv->scroller;
		_tmp21_ = gtk_scrolled_window_get_hadjustment (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = gtk_adjustment_get_value (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = diff_x;
		gtk_adjustment_set_value (_tmp22_, _tmp24_ + _tmp25_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean _image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = image_dialog_event_box_motion_notify_cb ((ImageDialog*) self, event);
	return result;
}


static gboolean image_dialog_event_box_button_press_cb (ImageDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp0_ = evt;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ == ((guint) 2)) {
		GdkEventButton* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		GdkEventButton* _tmp4_ = NULL;
		gdouble _tmp5_ = 0.0;
		_tmp2_ = evt;
		_tmp3_ = _tmp2_->x;
		self->priv->dnd_x = _tmp3_;
		_tmp4_ = evt;
		_tmp5_ = _tmp4_->y;
		self->priv->dnd_y = _tmp5_;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean _image_dialog_event_box_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = image_dialog_event_box_button_press_cb ((ImageDialog*) self, event);
	return result;
}


static void image_dialog_save_item_activated_cb (ImageDialog* self) {
	GtkFileChooserDialog* file_dialog = NULL;
	const gchar* _tmp0_ = NULL;
	GtkWindow* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkFileChooserDialog* _tmp4_ = NULL;
	gchar* filename = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GtkFileChooserDialog* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	GtkFileChooserDialog* _tmp9_ = NULL;
	gint response = 0;
	GtkFileChooserDialog* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_IMAGE_DIALOG (self));
	_tmp0_ = _ ("Save image");
	_tmp1_ = self->priv->parent;
	_tmp2_ = _ ("Cancel");
	_tmp3_ = _ ("Save");
	_tmp4_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_tmp0_, _tmp1_, GTK_FILE_CHOOSER_ACTION_SAVE, _tmp2_, GTK_RESPONSE_CANCEL, _tmp3_, GTK_RESPONSE_ACCEPT, NULL);
	g_object_ref_sink (_tmp4_);
	file_dialog = _tmp4_;
	_tmp5_ = self->priv->path;
	_tmp6_ = utils_get_file_name (_tmp5_);
	filename = _tmp6_;
	_tmp7_ = file_dialog;
	_tmp8_ = filename;
	gtk_file_chooser_set_current_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), _tmp8_);
	_tmp9_ = file_dialog;
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GTK_TYPE_WINDOW, GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow));
	_tmp10_ = file_dialog;
	_tmp11_ = gtk_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GTK_TYPE_DIALOG, GtkDialog));
	response = _tmp11_;
	_tmp12_ = response;
	if (_tmp12_ == ((gint) GTK_RESPONSE_ACCEPT)) {
		GFile* dest = NULL;
		GtkFileChooserDialog* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		GFile* _tmp16_ = NULL;
		GFile* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		GtkFileChooserDialog* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		GFile* source = NULL;
		const gchar* _tmp22_ = NULL;
		GFile* _tmp23_ = NULL;
		GtkFileChooserDialog* _tmp28_ = NULL;
		_tmp13_ = file_dialog;
		_tmp14_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
		_tmp15_ = _tmp14_;
		_tmp16_ = g_file_new_for_uri (_tmp15_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp15_);
		dest = _tmp17_;
		_tmp18_ = self->priv->path;
		g_debug ("ImageDialog.vala:121: Source: %s", _tmp18_);
		_tmp19_ = file_dialog;
		_tmp20_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
		_tmp21_ = _tmp20_;
		g_debug ("ImageDialog.vala:122: Destin: %s", _tmp21_);
		_g_free0 (_tmp21_);
		_tmp22_ = self->priv->path;
		_tmp23_ = g_file_new_for_path (_tmp22_);
		source = _tmp23_;
		{
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_ = NULL;
			_tmp24_ = source;
			_tmp25_ = dest;
			g_file_copy (_tmp24_, _tmp25_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch106_g_error;
			}
		}
		goto __finally106;
		__catch106_g_error:
		{
			GError* e = NULL;
			GError* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp26_ = e;
			_tmp27_ = _tmp26_->message;
			g_critical ("ImageDialog.vala:127: %s", _tmp27_);
			_g_error_free0 (e);
		}
		__finally106:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (source);
			_g_object_unref0 (dest);
			_g_free0 (filename);
			_g_object_unref0 (file_dialog);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp28_ = file_dialog;
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GTK_TYPE_WIDGET, GtkWidget));
		_g_object_unref0 (source);
		_g_object_unref0 (dest);
	} else {
		gint _tmp29_ = 0;
		_tmp29_ = response;
		if (_tmp29_ == ((gint) GTK_RESPONSE_CANCEL)) {
			GtkFileChooserDialog* _tmp30_ = NULL;
			_tmp30_ = file_dialog;
			gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GTK_TYPE_WIDGET, GtkWidget));
		}
	}
	_g_free0 (filename);
	_g_object_unref0 (file_dialog);
}


static void _image_dialog_save_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	image_dialog_save_item_activated_cb ((ImageDialog*) self);
}


static gboolean image_dialog_button_press_event_cb (ImageDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp0_ = evt;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ == ((guint) 3)) {
		GtkMenu* _tmp2_ = NULL;
		GdkEventButton* _tmp3_ = NULL;
		guint _tmp4_ = 0U;
		GdkEventButton* _tmp5_ = NULL;
		guint32 _tmp6_ = 0U;
		_tmp2_ = self->priv->image_context_menu;
		_tmp3_ = evt;
		_tmp4_ = _tmp3_->button;
		_tmp5_ = evt;
		_tmp6_ = _tmp5_->time;
		gtk_menu_popup (_tmp2_, NULL, NULL, NULL, NULL, _tmp4_, _tmp6_);
	} else {
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
	}
	result = TRUE;
	return result;
}


static gboolean _image_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = image_dialog_button_press_event_cb ((ImageDialog*) self, event);
	return result;
}


static gboolean image_dialog_key_press_event_cb (ImageDialog* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
	result = TRUE;
	return result;
}


static gboolean _image_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = image_dialog_key_press_event_cb ((ImageDialog*) self);
	return result;
}


static void image_dialog_class_init (ImageDialogClass * klass) {
	gint ImageDialog_private_offset;
	image_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ImageDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = image_dialog_finalize;
	ImageDialog_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/image-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scroller", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, scroller));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, image));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image_context_menu", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, image_context_menu));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "event_box_motion_notify_cb", G_CALLBACK(_image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "event_box_button_press_cb", G_CALLBACK(_image_dialog_event_box_button_press_cb_gtk_widget_button_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "save_item_activated_cb", G_CALLBACK(_image_dialog_save_item_activated_cb_gtk_menu_item_activate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_press_event_cb", G_CALLBACK(_image_dialog_button_press_event_cb_gtk_widget_button_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_image_dialog_key_press_event_cb_gtk_widget_key_press_event));
}


static void image_dialog_instance_init (ImageDialog * self) {
	self->priv = IMAGE_DIALOG_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void image_dialog_finalize (GObject* obj) {
	ImageDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_DIALOG, ImageDialog);
	_g_object_unref0 (self->priv->scroller);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->image_context_menu);
	_g_object_unref0 (self->priv->parent);
	_g_free0 (self->priv->path);
	G_OBJECT_CLASS (image_dialog_parent_class)->finalize (obj);
}


GType image_dialog_get_type (void) {
	static volatile gsize image_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&image_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageDialog), 0, (GInstanceInitFunc) image_dialog_instance_init, NULL };
		GType image_dialog_type_id;
		image_dialog_type_id = g_type_register_static (GTK_TYPE_WINDOW, "ImageDialog", &g_define_type_info, 0);
		g_once_init_leave (&image_dialog_type_id__volatile, image_dialog_type_id);
	}
	return image_dialog_type_id__volatile;
}



