/* VideoDialog.c generated by valac 0.25.1, the Vala compiler
 * generated from VideoDialog.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gst/gst.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/video/video.h>
#include <gdk/gdkx.h>
#include <libsoup/soup.h>
#include <float.h>
#include <math.h>


#define TYPE_VIDEO_DIALOG (video_dialog_get_type ())
#define VIDEO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_DIALOG, VideoDialog))
#define VIDEO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_DIALOG, VideoDialogClass))
#define IS_VIDEO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_DIALOG))
#define IS_VIDEO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_DIALOG))
#define VIDEO_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_DIALOG, VideoDialogClass))

typedef struct _VideoDialog VideoDialog;
typedef struct _VideoDialogClass VideoDialogClass;
typedef struct _VideoDialogPrivate VideoDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MEDIA (media_get_type ())
#define MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA, Media))
#define MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA, MediaClass))
#define IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA))
#define IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA))
#define MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA, MediaClass))

typedef struct _Media Media;
typedef struct _MediaClass MediaClass;
typedef struct _MediaPrivate MediaPrivate;

#define TYPE_MEDIA_TYPE (media_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block75Data Block75Data;
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _VideoDialogFetchRealUrlData VideoDialogFetchRealUrlData;
typedef struct _Block76Data Block76Data;
typedef struct _VideoDialogDownloadVideoData VideoDialogDownloadVideoData;

struct _VideoDialog {
	GtkWindow parent_instance;
	VideoDialogPrivate * priv;
};

struct _VideoDialogClass {
	GtkWindowClass parent_class;
};

struct _VideoDialogPrivate {
	GstElement* src;
	GstElement* sink;
	guint* xid;
	GtkStack* stack;
	GtkProgressBar* progress_bar;
	GtkDrawingArea* drawing_area;
	gint64 file_content_length;
	gint64 current_content_length;
	GCancellable* cancellable;
	GtkLabel* error_label;
};

typedef enum  {
	MEDIA_TYPE_IMAGE,
	MEDIA_TYPE_VINE,
	MEDIA_TYPE_GIF,
	MEDIA_TYPE_ANIMATED_GIF,
	MEDIA_TYPE_UNKNOWN
} MediaType;

struct _Media {
	GObject parent_instance;
	MediaPrivate * priv;
	gint64 id;
	gchar* path;
	gchar* thumb_path;
	gchar* url;
	MediaType type;
	GdkPixbuf* thumbnail;
	gboolean loaded;
	gboolean invalid;
};

struct _MediaClass {
	GObjectClass parent_class;
};

struct _Block75Data {
	int _ref_count_;
	VideoDialog* self;
	SoupSession* session;
	SoupMessage* msg;
	gchar* regex_str;
	gpointer _async_data_;
};

struct _VideoDialogFetchRealUrlData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	VideoDialog* self;
	gchar* first_url;
	gchar* regex_str;
	Block75Data* _data75_;
	const gchar* _tmp0_;
	SoupSession* _tmp1_;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	GCancellable* _tmp4_;
	SoupMessage* _tmp5_;
};

struct _Block76Data {
	int _ref_count_;
	VideoDialog* self;
	SoupSession* session;
	SoupMessage* msg;
	gpointer _async_data_;
};

struct _VideoDialogDownloadVideoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	VideoDialog* self;
	gchar* url;
	Block76Data* _data76_;
	SoupSession* _tmp0_;
	const gchar* _tmp1_;
	SoupMessage* _tmp2_;
	GCancellable* _tmp3_;
	SoupMessage* _tmp4_;
};


static gpointer video_dialog_parent_class = NULL;

GType video_dialog_get_type (void) G_GNUC_CONST;
#define VIDEO_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIDEO_DIALOG, VideoDialogPrivate))
enum  {
	VIDEO_DIALOG_DUMMY_PROPERTY
};
GType media_get_type (void) G_GNUC_CONST;
VideoDialog* video_dialog_new (GtkWindow* parent, Media* media);
VideoDialog* video_dialog_construct (GType object_type, GtkWindow* parent, Media* media);
static void video_dialog_realize_cb (VideoDialog* self);
static void _video_dialog_realize_cb_gtk_widget_realize (GtkWidget* _sender, gpointer self);
static GstBusSyncReply video_dialog_bus_sync_handler (VideoDialog* self, GstBus* bus, GstMessage* msg);
static GstBusSyncReply _video_dialog_bus_sync_handler_gst_bus_sync_handler (GstBus* bus, GstMessage* message, gpointer self);
static gboolean video_dialog_watch_cb (VideoDialog* self, GstBus* bus, GstMessage* msg);
static gboolean _video_dialog_watch_cb_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self);
GType media_type_get_type (void) G_GNUC_CONST;
static void video_dialog_fetch_real_url (VideoDialog* self, const gchar* first_url, const gchar* regex_str, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void video_dialog_fetch_real_url_finish (VideoDialog* self, GAsyncResult* _res_);
static gboolean video_dialog_button_press_event_cb (VideoDialog* self, GdkEventButton* evt);
static gboolean _video_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean video_dialog_key_press_event_cb (VideoDialog* self, GdkEventKey* evt);
static gboolean _video_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static void video_dialog_show_error (VideoDialog* self, const gchar* error_message);
static void video_dialog_stop (VideoDialog* self);
static void video_dialog_fetch_real_url_data_free (gpointer _data);
static gboolean video_dialog_fetch_real_url_co (VideoDialogFetchRealUrlData* _data_);
static Block75Data* block75_data_ref (Block75Data* _data75_);
static void block75_data_unref (void * _userdata_);
static void __lambda42_ (Block75Data* _data75_);
static void ___lambda42__g_cancellable_cancelled (GCancellable* _sender, gpointer self);
static void __lambda43_ (Block75Data* _data75_, SoupSession* s, SoupMessage* _msg);
static void video_dialog_download_video (VideoDialog* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void video_dialog_download_video_finish (VideoDialog* self, GAsyncResult* _res_);
static void ___lambda43__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
static void video_dialog_download_video_data_free (gpointer _data);
static gboolean video_dialog_download_video_co (VideoDialogDownloadVideoData* _data_);
static Block76Data* block76_data_ref (Block76Data* _data76_);
static void block76_data_unref (void * _userdata_);
static void __lambda44_ (Block76Data* _data76_);
static void ___lambda44__soup_message_got_headers (SoupMessage* _sender, gpointer self);
static void __lambda45_ (Block76Data* _data76_);
static void ___lambda45__g_cancellable_cancelled (GCancellable* _sender, gpointer self);
static void __lambda46_ (VideoDialog* self, SoupBuffer* buffer);
static void ___lambda46__soup_message_got_chunk (SoupMessage* _sender, SoupBuffer* chunk, gpointer self);
static void __lambda47_ (Block76Data* _data76_, SoupSession* s, SoupMessage* _msg);
static void ___lambda47__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
static void video_dialog_real_set_url (VideoDialog* self, const gchar* url);
static void video_dialog_finalize (GObject* obj);


static void _video_dialog_realize_cb_gtk_widget_realize (GtkWidget* _sender, gpointer self) {
	video_dialog_realize_cb ((VideoDialog*) self);
}


static GstBusSyncReply _video_dialog_bus_sync_handler_gst_bus_sync_handler (GstBus* bus, GstMessage* message, gpointer self) {
	GstBusSyncReply result;
	result = video_dialog_bus_sync_handler ((VideoDialog*) self, bus, message);
	return result;
}


static gboolean _video_dialog_watch_cb_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self) {
	gboolean result;
	result = video_dialog_watch_cb ((VideoDialog*) self, bus, message);
	return result;
}


static gboolean _video_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = video_dialog_button_press_event_cb ((VideoDialog*) self, event);
	return result;
}


static gboolean _video_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = video_dialog_key_press_event_cb ((VideoDialog*) self, event);
	return result;
}


VideoDialog* video_dialog_construct (GType object_type, GtkWindow* parent, Media* media) {
	VideoDialog * self = NULL;
	GtkWindow* _tmp0_ = NULL;
	GCancellable* _tmp1_ = NULL;
	GtkDrawingArea* _tmp2_ = NULL;
	GstElement* _tmp3_ = NULL;
	GstElement* _tmp4_ = NULL;
	GstElement* _tmp5_ = NULL;
	GstElement* _tmp6_ = NULL;
	GstBus* bus = NULL;
	GstElement* _tmp7_ = NULL;
	GstBus* _tmp8_ = NULL;
	GstBus* _tmp9_ = NULL;
	GstBus* _tmp10_ = NULL;
	Media* _tmp11_ = NULL;
	MediaType _tmp12_ = 0;
	GtkDrawingArea* _tmp21_ = NULL;
	GtkProgressBar* _tmp22_ = NULL;
	GtkProgressBar* _tmp23_ = NULL;
	GtkProgressBar* _tmp24_ = NULL;
	GtkLabel* _tmp25_ = NULL;
	GtkLabel* _tmp26_ = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkStack* _tmp28_ = NULL;
	GtkProgressBar* _tmp29_ = NULL;
	GtkStack* _tmp30_ = NULL;
	GtkDrawingArea* _tmp31_ = NULL;
	GtkStack* _tmp32_ = NULL;
	GtkLabel* _tmp33_ = NULL;
	GtkStack* _tmp34_ = NULL;
	GtkProgressBar* _tmp35_ = NULL;
	GtkStack* _tmp36_ = NULL;
	g_return_val_if_fail (GTK_IS_WINDOW (parent), NULL);
	g_return_val_if_fail (IS_MEDIA (media), NULL);
	self = (VideoDialog*) g_object_new (object_type, NULL);
	gtk_window_set_decorated (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), FALSE);
	gtk_window_set_modal (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), TRUE);
	_tmp0_ = parent;
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), _tmp0_);
	gtk_window_set_type_hint (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), GDK_WINDOW_TYPE_HINT_DIALOG);
	_tmp1_ = g_cancellable_new ();
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp1_;
	_tmp2_ = self->priv->drawing_area;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GTK_TYPE_WIDGET, GtkWidget), "realize", (GCallback) _video_dialog_realize_cb_gtk_widget_realize, self, 0);
	_tmp3_ = gst_element_factory_make ("playbin", "video");
	if (_tmp3_ != NULL) {
		g_object_ref_sink (_tmp3_);
	}
	_g_object_unref0 (self->priv->src);
	self->priv->src = _tmp3_;
	_tmp4_ = gst_element_factory_make ("xvimagesink", "sink");
	if (_tmp4_ != NULL) {
		g_object_ref_sink (_tmp4_);
	}
	_g_object_unref0 (self->priv->sink);
	self->priv->sink = _tmp4_;
	_tmp5_ = self->priv->src;
	_tmp6_ = self->priv->sink;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, G_TYPE_OBJECT, GObject), "video-sink", _tmp6_, NULL, NULL);
	_tmp7_ = self->priv->src;
	_tmp8_ = gst_element_get_bus (_tmp7_);
	bus = _tmp8_;
	_tmp9_ = bus;
	gst_bus_set_sync_handler (_tmp9_, _video_dialog_bus_sync_handler_gst_bus_sync_handler, g_object_ref (self), g_object_unref);
	_tmp10_ = bus;
	gst_bus_add_watch_full (_tmp10_, G_PRIORITY_DEFAULT, _video_dialog_watch_cb_gst_bus_func, g_object_ref (self), g_object_unref);
	_tmp11_ = media;
	_tmp12_ = _tmp11_->type;
	if (_tmp12_ == MEDIA_TYPE_VINE) {
		Media* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		_tmp13_ = media;
		_tmp14_ = _tmp13_->url;
		video_dialog_fetch_real_url (self, _tmp14_, "<meta property=\"twitter:player:stream\" content=\"(.*?)\"", NULL, NULL);
	} else {
		Media* _tmp15_ = NULL;
		MediaType _tmp16_ = 0;
		_tmp15_ = media;
		_tmp16_ = _tmp15_->type;
		if (_tmp16_ == MEDIA_TYPE_ANIMATED_GIF) {
			Media* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			_tmp17_ = media;
			_tmp18_ = _tmp17_->url;
			video_dialog_fetch_real_url (self, _tmp18_, "<source video-src=\"(.*?)\" type=\"video/mp4\"", NULL, NULL);
		} else {
			Media* _tmp19_ = NULL;
			MediaType _tmp20_ = 0;
			_tmp19_ = media;
			_tmp20_ = _tmp19_->type;
			g_critical ("VideoDialog.vala:52: Unknown video media type: %d", (gint) _tmp20_);
		}
	}
	_tmp21_ = self->priv->drawing_area;
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GTK_TYPE_WIDGET, GtkWidget), 435, 435);
	_tmp22_ = self->priv->progress_bar;
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GTK_TYPE_WIDGET, GtkWidget), GTK_ALIGN_CENTER);
	_tmp23_ = self->priv->progress_bar;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GTK_TYPE_WIDGET, GtkWidget), "margin", 20, NULL);
	_tmp24_ = self->priv->progress_bar;
	gtk_progress_bar_set_show_text (_tmp24_, TRUE);
	_tmp25_ = self->priv->error_label;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GTK_TYPE_WIDGET, GtkWidget), "margin", 20, NULL);
	_tmp26_ = self->priv->error_label;
	g_object_set (_tmp26_, "wrap", TRUE, NULL);
	_tmp27_ = self->priv->error_label;
	gtk_label_set_selectable (_tmp27_, TRUE);
	_tmp28_ = self->priv->stack;
	_tmp29_ = self->priv->progress_bar;
	gtk_stack_add_named (_tmp28_, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GTK_TYPE_WIDGET, GtkWidget), "progress");
	_tmp30_ = self->priv->stack;
	_tmp31_ = self->priv->drawing_area;
	gtk_stack_add_named (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GTK_TYPE_WIDGET, GtkWidget), "video");
	_tmp32_ = self->priv->stack;
	_tmp33_ = self->priv->error_label;
	gtk_stack_add_named (_tmp32_, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GTK_TYPE_WIDGET, GtkWidget), "error");
	_tmp34_ = self->priv->stack;
	_tmp35_ = self->priv->progress_bar;
	gtk_stack_set_visible_child (_tmp34_, G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GTK_TYPE_WIDGET, GtkWidget));
	_tmp36_ = self->priv->stack;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_CONTAINER, GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GTK_TYPE_WIDGET, GtkWidget));
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), "button-press-event", (GCallback) _video_dialog_button_press_event_cb_gtk_widget_button_press_event, self, 0);
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), "key-press-event", (GCallback) _video_dialog_key_press_event_cb_gtk_widget_key_press_event, self, 0);
	_g_object_unref0 (bus);
	return self;
}


VideoDialog* video_dialog_new (GtkWindow* parent, Media* media) {
	return video_dialog_construct (TYPE_VIDEO_DIALOG, parent, media);
}


static void video_dialog_show_error (VideoDialog* self, const gchar* error_message) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GtkStack* _tmp2_ = NULL;
	g_return_if_fail (IS_VIDEO_DIALOG (self));
	g_return_if_fail (error_message != NULL);
	_tmp0_ = self->priv->error_label;
	_tmp1_ = error_message;
	gtk_label_set_label (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp2_, "error");
}


static gboolean video_dialog_button_press_event_cb (VideoDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO_DIALOG (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	video_dialog_stop (self);
	result = TRUE;
	return result;
}


static gboolean video_dialog_key_press_event_cb (VideoDialog* self, GdkEventKey* evt) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO_DIALOG (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	video_dialog_stop (self);
	result = TRUE;
	return result;
}


static void video_dialog_stop (VideoDialog* self) {
	GCancellable* _tmp0_ = NULL;
	GstElement* _tmp1_ = NULL;
	g_return_if_fail (IS_VIDEO_DIALOG (self));
	_tmp0_ = self->priv->cancellable;
	g_cancellable_cancel (_tmp0_);
	_tmp1_ = self->priv->src;
	gst_element_set_state (_tmp1_, GST_STATE_NULL);
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GstBusSyncReply video_dialog_bus_sync_handler (VideoDialog* self, GstBus* bus, GstMessage* msg) {
	GstBusSyncReply result = 0;
	GstMessage* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GstVideoOverlay* overlay = NULL;
	GstMessage* _tmp2_ = NULL;
	GstObject* _tmp3_ = NULL;
	GstVideoOverlay* _tmp4_ = NULL;
	GstVideoOverlay* _tmp5_ = NULL;
	guint* _tmp6_ = NULL;
	g_return_val_if_fail (IS_VIDEO_DIALOG (self), 0);
	g_return_val_if_fail (GST_IS_BUS (bus), 0);
	g_return_val_if_fail (msg != NULL, 0);
	_tmp0_ = msg;
	_tmp1_ = gst_is_video_overlay_prepare_window_handle_message (_tmp0_);
	if (!_tmp1_) {
		result = GST_BUS_PASS;
		return result;
	}
	_tmp2_ = msg;
	_tmp3_ = _tmp2_->src;
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gst_video_overlay_get_type (), GstVideoOverlay));
	overlay = _tmp4_;
	_tmp5_ = overlay;
	_tmp6_ = self->priv->xid;
	gst_video_overlay_set_window_handle (_tmp5_, (guintptr) _tmp6_);
	result = GST_BUS_DROP;
	_g_object_unref0 (overlay);
	return result;
}


static gboolean video_dialog_watch_cb (VideoDialog* self, GstBus* bus, GstMessage* msg) {
	gboolean result = FALSE;
	GstMessage* _tmp0_ = NULL;
	GstMessageType _tmp1_ = 0;
	g_return_val_if_fail (IS_VIDEO_DIALOG (self), FALSE);
	g_return_val_if_fail (GST_IS_BUS (bus), FALSE);
	g_return_val_if_fail (msg != NULL, FALSE);
	_tmp0_ = msg;
	_tmp1_ = _tmp0_->type;
	if (_tmp1_ == GST_MESSAGE_EOS) {
		GstElement* _tmp2_ = NULL;
		_tmp2_ = self->priv->src;
		gst_element_seek (_tmp2_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, (gint64) 0, GST_SEEK_TYPE_NONE, (gint64) (-1));
	}
	result = TRUE;
	return result;
}


static void video_dialog_realize_cb (VideoDialog* self) {
	GtkDrawingArea* _tmp0_ = NULL;
	GdkWindow* _tmp1_ = NULL;
	Window _tmp2_ = 0;
	g_return_if_fail (IS_VIDEO_DIALOG (self));
	_tmp0_ = self->priv->drawing_area;
	_tmp1_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WIDGET, GtkWidget));
	_tmp2_ = gdk_x11_window_get_xid (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gdk_x11_window_get_type (), GdkX11Window));
	self->priv->xid = (guint*) _tmp2_;
}


static void video_dialog_fetch_real_url_data_free (gpointer _data) {
	VideoDialogFetchRealUrlData* _data_;
	_data_ = _data;
	_g_free0 (_data_->first_url);
	_g_object_unref0 (_data_->self);
	g_slice_free (VideoDialogFetchRealUrlData, _data_);
}


static void video_dialog_fetch_real_url (VideoDialog* self, const gchar* first_url, const gchar* regex_str, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	VideoDialogFetchRealUrlData* _data_;
	VideoDialog* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_data_ = g_slice_new0 (VideoDialogFetchRealUrlData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, video_dialog_fetch_real_url);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, video_dialog_fetch_real_url_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = first_url;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->first_url);
	_data_->first_url = _tmp2_;
	_tmp3_ = regex_str;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->regex_str);
	_data_->regex_str = _tmp4_;
	video_dialog_fetch_real_url_co (_data_);
}


static void video_dialog_fetch_real_url_finish (VideoDialog* self, GAsyncResult* _res_) {
	VideoDialogFetchRealUrlData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static Block75Data* block75_data_ref (Block75Data* _data75_) {
	g_atomic_int_inc (&_data75_->_ref_count_);
	return _data75_;
}


static void block75_data_unref (void * _userdata_) {
	Block75Data* _data75_;
	_data75_ = (Block75Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data75_->_ref_count_)) {
		VideoDialog* self;
		self = _data75_->self;
		_g_object_unref0 (_data75_->msg);
		_g_object_unref0 (_data75_->session);
		_g_free0 (_data75_->regex_str);
		_g_object_unref0 (self);
		g_slice_free (Block75Data, _data75_);
	}
}


static void __lambda42_ (Block75Data* _data75_) {
	VideoDialog* self;
	self = _data75_->self;
	soup_session_cancel_message (_data75_->session, _data75_->msg, (guint) SOUP_STATUS_CANCELLED);
}


static void ___lambda42__g_cancellable_cancelled (GCancellable* _sender, gpointer self) {
	__lambda42_ (self);
}


static void __lambda43_ (Block75Data* _data75_, SoupSession* s, SoupMessage* _msg) {
	VideoDialog* self;
	SoupMessage* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	gchar* back = NULL;
	SoupMessage* _tmp6_ = NULL;
	SoupMessageBody* _tmp7_ = NULL;
	guint8* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gchar* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
	self = _data75_->self;
	g_return_if_fail (SOUP_IS_SESSION (s));
	g_return_if_fail (SOUP_IS_MESSAGE (_msg));
	_tmp0_ = _msg;
	g_object_get (_tmp0_, "status-code", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != ((guint) SOUP_STATUS_OK)) {
		SoupMessage* _tmp3_ = NULL;
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
		_tmp3_ = _msg;
		g_object_get (_tmp3_, "status-code", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		g_warning ("VideoDialog.vala:139: Status Code %u", _tmp5_);
		video_dialog_fetch_real_url_co (_data75_->_async_data_);
		return;
	}
	_tmp6_ = _msg;
	_tmp7_ = _tmp6_->response_body;
	_tmp8_ = _tmp7_->data;
	_tmp8__length1 = (gint) _tmp7_->length;
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
	back = _tmp9_;
	{
		GRegex* regex = NULL;
		const gchar* _tmp10_ = NULL;
		GRegex* _tmp11_ = NULL;
		GMatchInfo* info = NULL;
		GRegex* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		GMatchInfo* _tmp14_ = NULL;
		gchar* real_url = NULL;
		GMatchInfo* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		_tmp10_ = _data75_->regex_str;
		_tmp11_ = g_regex_new (_tmp10_, 0, 0, &_inner_error_);
		regex = _tmp11_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch112_g_regex_error;
			}
			_g_free0 (back);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp12_ = regex;
		_tmp13_ = back;
		g_regex_match (_tmp12_, _tmp13_, 0, &_tmp14_);
		_g_match_info_unref0 (info);
		info = _tmp14_;
		_tmp15_ = info;
		_tmp16_ = g_match_info_fetch (_tmp15_, 1);
		real_url = _tmp16_;
		_tmp17_ = real_url;
		if (_tmp17_ == NULL) {
			video_dialog_show_error (self, "Error: Could not get real URL");
		} else {
			const gchar* _tmp18_ = NULL;
			_tmp18_ = real_url;
			video_dialog_download_video (self, _tmp18_, NULL, NULL);
		}
		_g_free0 (real_url);
		_g_match_info_unref0 (info);
		_g_regex_unref0 (regex);
	}
	goto __finally112;
	__catch112_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		GError* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = e;
		_tmp20_ = _tmp19_->message;
		g_warning ("VideoDialog.vala:154: Regex error: %s", _tmp20_);
		_tmp21_ = e;
		_tmp22_ = _tmp21_->message;
		_tmp23_ = g_strdup_printf ("Regex error: %s", _tmp22_);
		_tmp24_ = _tmp23_;
		video_dialog_show_error (self, _tmp24_);
		_g_free0 (_tmp24_);
		_g_error_free0 (e);
	}
	__finally112:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (back);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	video_dialog_fetch_real_url_co (_data75_->_async_data_);
	_g_free0 (back);
}


static void ___lambda43__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
	__lambda43_ (self, session, msg);
	block75_data_unref (self);
}


static gboolean video_dialog_fetch_real_url_co (VideoDialogFetchRealUrlData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data75_ = g_slice_new0 (Block75Data);
	_data_->_data75_->_ref_count_ = 1;
	_data_->_data75_->self = g_object_ref (_data_->self);
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->regex_str;
	_g_free0 (_data_->_data75_->regex_str);
	_data_->_data75_->regex_str = _data_->_tmp0_;
	_data_->_data75_->_async_data_ = _data_;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = soup_session_new ();
	_data_->_data75_->session = _data_->_tmp1_;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->first_url;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = soup_message_new ("GET", _data_->_tmp2_);
	_data_->_data75_->msg = _data_->_tmp3_;
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->self->priv->cancellable;
	g_signal_connect_data (_data_->_tmp4_, "cancelled", (GCallback) ___lambda42__g_cancellable_cancelled, block75_data_ref (_data_->_data75_), (GClosureNotify) block75_data_unref, 0);
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = _g_object_ref0 (_data_->_data75_->msg);
	soup_session_queue_message (_data_->_data75_->session, _data_->_tmp5_, ___lambda43__soup_session_callback, block75_data_ref (_data_->_data75_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block75_data_unref (_data_->_data75_);
	_data_->_data75_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void video_dialog_download_video_data_free (gpointer _data) {
	VideoDialogDownloadVideoData* _data_;
	_data_ = _data;
	_g_free0 (_data_->url);
	_g_object_unref0 (_data_->self);
	g_slice_free (VideoDialogDownloadVideoData, _data_);
}


static void video_dialog_download_video (VideoDialog* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	VideoDialogDownloadVideoData* _data_;
	VideoDialog* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	_data_ = g_slice_new0 (VideoDialogDownloadVideoData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, video_dialog_download_video);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, video_dialog_download_video_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = url;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->url);
	_data_->url = _tmp2_;
	video_dialog_download_video_co (_data_);
}


static void video_dialog_download_video_finish (VideoDialog* self, GAsyncResult* _res_) {
	VideoDialogDownloadVideoData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static Block76Data* block76_data_ref (Block76Data* _data76_) {
	g_atomic_int_inc (&_data76_->_ref_count_);
	return _data76_;
}


static void block76_data_unref (void * _userdata_) {
	Block76Data* _data76_;
	_data76_ = (Block76Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data76_->_ref_count_)) {
		VideoDialog* self;
		self = _data76_->self;
		_g_object_unref0 (_data76_->msg);
		_g_object_unref0 (_data76_->session);
		_g_object_unref0 (self);
		g_slice_free (Block76Data, _data76_);
	}
}


static void __lambda44_ (Block76Data* _data76_) {
	VideoDialog* self;
	SoupMessageHeaders* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	self = _data76_->self;
	_tmp0_ = _data76_->msg->response_headers;
	_tmp1_ = soup_message_headers_get_content_length (_tmp0_);
	self->priv->file_content_length = _tmp1_;
}


static void ___lambda44__soup_message_got_headers (SoupMessage* _sender, gpointer self) {
	__lambda44_ (self);
}


static void __lambda45_ (Block76Data* _data76_) {
	VideoDialog* self;
	self = _data76_->self;
	soup_session_cancel_message (_data76_->session, _data76_->msg, (guint) SOUP_STATUS_CANCELLED);
}


static void ___lambda45__g_cancellable_cancelled (GCancellable* _sender, gpointer self) {
	__lambda45_ (self);
}


static void __lambda46_ (VideoDialog* self, SoupBuffer* buffer) {
	gint64 _tmp0_ = 0LL;
	SoupBuffer* _tmp1_ = NULL;
	gsize _tmp2_ = 0UL;
	gdouble fraction = 0.0;
	gint64 _tmp3_ = 0LL;
	gint64 _tmp4_ = 0LL;
	GtkProgressBar* _tmp5_ = NULL;
	GtkProgressBar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	g_return_if_fail (buffer != NULL);
	_tmp0_ = self->priv->current_content_length;
	_tmp1_ = buffer;
	_tmp2_ = _tmp1_->length;
	self->priv->current_content_length = _tmp0_ + _tmp2_;
	_tmp3_ = self->priv->current_content_length;
	_tmp4_ = self->priv->file_content_length;
	fraction = ((gdouble) _tmp3_) / ((gdouble) _tmp4_);
	_tmp5_ = self->priv->progress_bar;
	gtk_progress_bar_set_fraction (_tmp5_, fraction);
	_tmp6_ = self->priv->progress_bar;
	_tmp7_ = g_strdup_printf ("%d%%", (gint) (fraction * 100));
	_tmp8_ = _tmp7_;
	gtk_progress_bar_set_text (_tmp6_, _tmp8_);
	_g_free0 (_tmp8_);
}


static void ___lambda46__soup_message_got_chunk (SoupMessage* _sender, SoupBuffer* chunk, gpointer self) {
	__lambda46_ ((VideoDialog*) self, chunk);
}


static void __lambda47_ (Block76Data* _data76_, SoupSession* s, SoupMessage* _msg) {
	VideoDialog* self;
	SoupMessage* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	gchar* b64 = NULL;
	SoupMessageBody* _tmp6_ = NULL;
	guint8* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gchar* _tmp8_ = NULL;
	gchar* sa = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	GstElement* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	GtkStack* _tmp13_ = NULL;
	GstElement* _tmp14_ = NULL;
	self = _data76_->self;
	g_return_if_fail (SOUP_IS_SESSION (s));
	g_return_if_fail (SOUP_IS_MESSAGE (_msg));
	_tmp0_ = _msg;
	g_object_get (_tmp0_, "status-code", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != ((guint) SOUP_STATUS_OK)) {
		SoupMessage* _tmp3_ = NULL;
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
		_tmp3_ = _msg;
		g_object_get (_tmp3_, "status-code", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		g_warning ("VideoDialog.vala:181: Status Code %u", _tmp5_);
		video_dialog_download_video_co (_data76_->_async_data_);
		return;
	}
	_tmp6_ = _data76_->msg->response_body;
	_tmp7_ = _tmp6_->data;
	_tmp7__length1 = (gint) _tmp6_->length;
	_tmp8_ = g_base64_encode ((guchar*) _tmp7_, (_tmp7__length1 * sizeof (guint8)) / sizeof (guchar));
	b64 = _tmp8_;
	_tmp9_ = b64;
	_tmp10_ = g_strconcat ("data:;base64,", _tmp9_, NULL);
	sa = _tmp10_;
	_tmp11_ = self->priv->src;
	_tmp12_ = sa;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, G_TYPE_OBJECT, GObject), "uri", _tmp12_, NULL);
	_tmp13_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp13_, "video");
	_tmp14_ = self->priv->src;
	gst_element_set_state (_tmp14_, GST_STATE_PLAYING);
	video_dialog_download_video_co (_data76_->_async_data_);
	_g_free0 (sa);
	_g_free0 (b64);
}


static void ___lambda47__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
	__lambda47_ (self, session, msg);
	block76_data_unref (self);
}


static gboolean video_dialog_download_video_co (VideoDialogDownloadVideoData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data76_ = g_slice_new0 (Block76Data);
	_data_->_data76_->_ref_count_ = 1;
	_data_->_data76_->self = g_object_ref (_data_->self);
	_data_->_data76_->_async_data_ = _data_;
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = soup_session_new ();
	_data_->_data76_->session = _data_->_tmp0_;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->url;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = soup_message_new ("GET", _data_->_tmp1_);
	_data_->_data76_->msg = _data_->_tmp2_;
	g_signal_connect_data (_data_->_data76_->msg, "got-headers", (GCallback) ___lambda44__soup_message_got_headers, block76_data_ref (_data_->_data76_), (GClosureNotify) block76_data_unref, 0);
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = _data_->self->priv->cancellable;
	g_signal_connect_data (_data_->_tmp3_, "cancelled", (GCallback) ___lambda45__g_cancellable_cancelled, block76_data_ref (_data_->_data76_), (GClosureNotify) block76_data_unref, 0);
	g_signal_connect_object (_data_->_data76_->msg, "got-chunk", (GCallback) ___lambda46__soup_message_got_chunk, _data_->self, 0);
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _g_object_ref0 (_data_->_data76_->msg);
	soup_session_queue_message (_data_->_data76_->session, _data_->_tmp4_, ___lambda47__soup_session_callback, block76_data_ref (_data_->_data76_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block76_data_unref (_data_->_data76_);
	_data_->_data76_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void video_dialog_real_set_url (VideoDialog* self, const gchar* url) {
	g_return_if_fail (IS_VIDEO_DIALOG (self));
	g_return_if_fail (url != NULL);
}


static void video_dialog_class_init (VideoDialogClass * klass) {
	video_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VideoDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = video_dialog_finalize;
}


static void video_dialog_instance_init (VideoDialog * self) {
	GtkStack* _tmp0_ = NULL;
	GtkProgressBar* _tmp1_ = NULL;
	GtkDrawingArea* _tmp2_ = NULL;
	GtkLabel* _tmp3_ = NULL;
	self->priv = VIDEO_DIALOG_GET_PRIVATE (self);
	_tmp0_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->stack = _tmp0_;
	_tmp1_ = (GtkProgressBar*) gtk_progress_bar_new ();
	g_object_ref_sink (_tmp1_);
	self->priv->progress_bar = _tmp1_;
	_tmp2_ = (GtkDrawingArea*) gtk_drawing_area_new ();
	g_object_ref_sink (_tmp2_);
	self->priv->drawing_area = _tmp2_;
	self->priv->file_content_length = (gint64) (-1);
	self->priv->current_content_length = (gint64) 0;
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp3_);
	self->priv->error_label = _tmp3_;
}


static void video_dialog_finalize (GObject* obj) {
	VideoDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_DIALOG, VideoDialog);
	_g_object_unref0 (self->priv->src);
	_g_object_unref0 (self->priv->sink);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->progress_bar);
	_g_object_unref0 (self->priv->drawing_area);
	_g_object_unref0 (self->priv->cancellable);
	_g_object_unref0 (self->priv->error_label);
	G_OBJECT_CLASS (video_dialog_parent_class)->finalize (obj);
}


GType video_dialog_get_type (void) {
	static volatile gsize video_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&video_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoDialog), 0, (GInstanceInitFunc) video_dialog_instance_init, NULL };
		GType video_dialog_type_id;
		video_dialog_type_id = g_type_register_static (GTK_TYPE_WINDOW, "VideoDialog", &g_define_type_info, 0);
		g_once_init_leave (&video_dialog_type_id__volatile, video_dialog_type_id);
	}
	return video_dialog_type_id__volatile;
}



